;Ŀ
;                 Joe Forster/STA                 
;                                                 
;                    CRC32.PAS                    
;                                                 
;                CRC32 Calculator                 
;

		jumps

CSeg		segment
		assume	cs:CSeg, ds:CSeg, ss:CSeg
		org	0100h

BufferSize	equ	64512
ProgramSize	equ	4096

Main:		mov	di, Offset DataStart
		mov	cx, DataEnd - DataStart
		xor	al, al
		cld
		rep	stosb
		mov	ax, ds:[0006h]
		cmp	ax, ProgramSize
		jbe	@18
		mov	bx, ProgramSize / 16
		mov	ah, 4Ah
		int	21h
		mov	sp, ProgramSize
		xor	ax, ax
		push	ax
@18:		mov	bl, 1
		mov	di, Offset SearchPar
		mov	cx, 79
		call	ParamStr
		or	bh, bh
		jne	@01
		mov	dx, Offset Hello
		mov	ah, 9
		int	21h
		mov	dx, Offset Usage
		mov	ah, 9
		int	21h
		xor	al, al
		jmp	@03
@01:		mov	si, Offset SearchPar
		mov	di, Offset ReadPath
		mov	bx, Offset ReadName
		mov	bp, Offset ReadExt
		call	FSplit
		mov	si, Offset ReadPath
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset ReadName
		clc
		call	StrCopy
		mov	si, Offset ReadExt
		stc
		call	StrCopy
		mov	dx, Offset SearchPar
		mov	cx, 27h
		mov	ah, 4Eh
		int	21h
		jnc	@06
		mov	dx, Offset SearchPar
		clc
		call	PrintStr
		mov	dx, Offset NotFound
		jmp	@02
@06:		call	MakeCRC
		mov	si, 009Eh
		xor	di, di
		mov	bx, Offset ReadName
		mov	bp, Offset ReadExt
		call	FSplit
		mov	si, Offset ReadPath
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, 009Eh
		stc
		call	StrCopy
		mov	dx, Offset SearchPar
		mov	ax, 3D00h
		int	21h
		jnc	@07
		jmp	@04
@07:		mov	si, ax
		mov	bx, BufferSize / 16
		mov	ah, 48h
		int	21h
		jnc	@10
		mov	dx, Offset NoMemory
		jmp	@02
@10:		mov	Buffer, ax
		xor	ax, ax
		mov	word ptr CRC[0], ax
		mov	word ptr CRC[2], ax
		mov	bx, si
		mov	ax, 4202h
		xor	cx, cx
		xor	dx, dx
		int	21h
		mov	word ptr ReadLen[0], ax
		mov	word ptr ReadLen[2], dx
		mov	ax, 4200h
		xor	cx, cx
		xor	dx, dx
		int	21h
		xor	ax, ax
		mov	word ptr Pos[0], ax
		mov	word ptr Pos[2], ax
@14:		mov	ax, word ptr ReadLen[0]
		mov	dx, word ptr ReadLen[2]
		mov	bx, word ptr Pos[0]
		mov	cx, word ptr Pos[2]
		sub	ax, bx
		sbb	dx, cx
		jc	@15
		or	dx, dx
		jne	@16
		or	ax, ax
		je	@15
		cmp	ax, BufferSize
		jbe	@17
@16:		mov	ax, BufferSize
@17:		mov	cx, ax
		mov	ax, word ptr Pos[0]
		mov	dx, word ptr Pos[2]
		add	ax, cx
		adc	dx, 0
		mov	word ptr Pos[0], ax
		mov	word ptr Pos[2], dx
		mov	bx, si
		mov	ax, Buffer
		call	BlockRead
		push	si
		push	cx
		push	es
		xor	si, si
		mov	di, cx
		mov	cx, word ptr CRC[0]
		mov	dx, word ptr CRC[2]
		not	cx
		not	dx
		mov	es, Buffer
@05:		xor	bx, bx
		mov	bl, es:[si]
		xor	bl, cl
		mov	cl, ch
		mov	ch, dl
		mov	dl, dh
		xor	dh, dh
		shl	bx, 2
		xor	cx, word ptr CRCTable[bx][0]
		xor	dx, word ptr CRCTable[bx][2]
		inc	si
		dec	di
		jne	@05
		pop	es
		not	cx
		not	dx
		mov	word ptr CRC[0], cx
		mov	word ptr CRC[2], dx
		pop	cx
		pop	si
		jmp	@14
@15:		mov	dx, Offset SearchPar
		clc
		call	PrintStr
		mov	dl, 9
		mov	ah, 6
		int	21h
		mov	ax, word ptr CRC[0]
		mov	dx, word ptr CRC[2]
		mov	cx, 0830h
		call	HexStr
		stc
		call	PrintStr
		push	es
		mov	es, Buffer
		mov	ah, 49h
		int	21h
		pop	es
@09:		mov	bx, si
		mov	ah, 3Eh
		int	21h
@04:		mov	ah, 4Fh
		int	21h
		jc	@03
		jmp	@06
@02:		mov	ah, 9
		int	21h
		mov	al, 1
		jmp	@19
@03:		xor	al, al
@19:		mov	ah, 4Ch
		int	21h

MakeCRC:	xor	si, si
		mov	di, Offset CRCTable
		cld
@03_MakeCRC:	mov	ax, si
		xor	bx, bx
		mov	cx, 8
@02_MakeCRC:	shr	bx, 1
		rcr	ax, 1
		jnc	@01_MakeCRC
		xor	ax, 08320h
		xor	bx, 0EDB8h
@01_MakeCRC:	loop	@02_MakeCRC
		stosw
		mov	ax, bx
		stosw
		inc	si
		cmp	si, 256
		jbe	@03_MakeCRC
		retn

BlockRead:	push	ds
		push	dx
		mov	ds, ax
		xor	dx, dx
		mov	ah, 3Fh
		int	21h
		pop	dx
		pop	ds
		retn

HexStr:		mov	bx, 10h
		jmp	NumStr
DecStr:		mov	bx, 10
		xor	cx, cx
NumStr:		push	si
		push	di
		push	cx
		mov	si, bx
		mov	di, Offset NumStrBuffer[10]
		mov	byte ptr [di], 0
		mov	cx, di
		mov	bx, dx
@01_NumStr:	xor	dx, dx
		xchg	bx, ax
		div	si
		xchg	bx, ax
		div	si
		add	dl, '0'
		cmp	dl, '9'
		jbe	@02_NumStr
		add	dl, 'A' - '0' - 10
@02_NumStr:	dec	di
		mov	[di], dl
		mov	dx, ax
		or	dx, bx
		jne	@01_NumStr
		sub	cx, di
		pop	bx
		or	bh, bh
		je	@03_NumStr
		sub	bh, cl
		jbe	@03_NumStr
@04_NumStr:	dec	di
		mov	byte ptr [di], bl
		inc	cx
		dec	bh
		jne	@04_NumStr
@03_NumStr:	mov	dx, di
		pop	di
		pop	si
		retn

FSplit:		mov	dx, si
		call	StrLen
		add	si, ax
		dec	si
		xor	cx, cx
		std
@04_FSplit:	cmp	si, dx
		jb	@01_FSplit
		lodsb
		cmp	al, '.'
		jne	@02_FSplit
		or	cx, cx
		jne	@02_FSplit
		mov	cx, si
		inc	cx
@02_FSplit:	cmp	al, '\'
		je	@03_FSplit
		cmp	al, ':'
		jne	@04_FSplit
@03_FSplit:	inc	si
@01_FSplit:	inc	si
		or	cx, cx
		jne	@05_FSplit
		mov	cx, dx
		xchg	si, dx
		call	StrLen
		xchg	si, dx
		add	cx, ax
@05_FSplit:	xchg	si, dx
		sub	cx, dx
		sub	dx, si
		push	cx
		mov	cx, 67
		stc
		call	StrPartCopy
		mov	di, bx
		pop	dx
		mov	cx, 8
		stc
		call	StrPartCopy
		mov	di, bp
		mov	cx, 4
		stc
		call	StrCopy
		retn

StrCopy:	mov	dx, cx
StrPartCopy:	cld
		pushf
		or	di, di
		jne	@04_StrCopy
		popf
		retn
@04_StrCopy:	or	cx, cx
		je	@01_StrCopy
@02_StrCopy:	or	dx, dx
		je	@01_StrCopy
		lodsb
		or	al, al
		je	@01_StrCopy
		stosb
		dec	dx
		loop	@02_StrCopy
@01_StrCopy:	xor	al, al
		popf
		jnc	@03_StrCopy
		stosb
@03_StrCopy:	retn

StrLen:		cld
		push	si
		xor	ah, ah
@02_StrLen:	lodsb
		or	al, al
		je	@01_StrLen
		inc	ah
		or	ah, ah
		jne	@02_StrLen
@01_StrLen:	pop	si
		mov	al, ah
		xor	ah, ah
		retn

PrintStr:	push	si
		push	bx
		push	cx
		pushf
		mov	si, dx
		mov	bx, 1
		call	StrLen
		or	ax, ax
		je	@01_PrintStr
		mov	cx, ax
		mov	ah, 40h
		int	21h
@01_PrintStr:	popf
		jnc	@02_PrintStr
		mov	dx, Offset LineFeed
		mov	cx, 2
		mov	ah, 40h
		int	21h
@02_PrintStr:	pop	cx
		pop	bx
		pop	si
		retn

ParamStr:	mov	si, 0081h
		xor	bh, bh
@01_ParamStr:	lodsb
		cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		inc	bh
		cmp	bl, bh
		je	@03_ParamStr
@04_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		lodsb
		jmp	@04_ParamStr
@03_ParamStr:	or	di, di
		je	@05_ParamStr
@06_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@02_ParamStr
		cmp	al, 9
		je	@02_ParamStr
		call	UpCase
		stosb
		lodsb
		loop	@06_ParamStr
@02_ParamStr:	xor	al, al
		stosb
@05_ParamStr:	retn

UpCase:		cmp	al, 'a'
		jb	@01_UpCase
		cmp	al, 'z'
		ja	@01_UpCase
		sub	al, 'a' - 'A'
@01_UpCase:	retn

Hello		db	'CRC32 Calculator by Joe Forster/STA', 13, 10, 13, 10, '$'
Usage		db	'This program calculates the 32-bit CRC checksum of binary files.', 13, 10, 13, 10
		db	'Usage: CRC32 <filename>', 13, 10, '$'
NotFound	db	' not found', 13, 10, '$'
NoMemory	db	'Out of memory', 13, 10, '$'
LineFeed	db	13, 10

DataStart:

ReadLen		dd	?
Pos		dd	?
CRC		dd	?
Buffer		dw	?
BufferLen	dw	?
SearchPar	db	79 + 1 dup (?)
ReadPath	db	79 + 1 dup (?)
ReadName	db	8 + 1 dup (?)
ReadExt		db	4 + 1 dup (?)
NumStrBuffer	db	10 + 1 dup (?)

CRCTable	dd	256 dup (?)

DataEnd:

CSeg		ends

		end	Main
